--TODO----------------------------------------------------
----------------------------------------------------------
	--[[
		- add an option for smartscan (will scan players every N seconds)
			- this may require a complete control override of the til library?
				- will have to manually reset variables when it's done			
		x add addons option page
			- add options and function to handle option changes
			- make sure leaving a group will reset the roster properly as well
				- are more than one entry being deleted when deletions need to take place? seems like one
	--]]
	
--set public variables------------------------------------
----------------------------------------------------------

	--options
		local debug = false;
		
	--colors
		local spec_c =		"ffffff";
		local til_c =		"00ccff";
		local boa_c =		"e6cc80";
		local pvp_c =		"a335ee";
		local miss_c =		"ff0000";
		local disabled_c =	"333333";
		
		local party_c	=	"aaaaff";
		local raid_c	=	"ff7f00";
		local nogroup_c	=	"888888";

--set protected variables---------------------------------
----------------------------------------------------------

	--constants
		--how many seconds after roster changes before beginning scans
		--this is to compensate for the overabundance of events that
		--are fired when the roster is changed
		local rosterSettleTime = 3;
		local rosterNextUpdate;
		local serverName = GetCVar("realmName");
		
		local tagNew =		"|cffff9e00Unscanned|r";
		local tagScanned =	"|cff00ff00Scanned|r";
		local tagReady =	"Ready To Scan";
		
	--other
		local settledCount, last_rosterCount, rosterCount, partyType;
		if (not rosterCache) then
			rosterCache = {};
		end
		
		if (not rosterSize) then
			rosterSize = 1;
			last_rosterCount = 1;
			settledCount = 1;
		else
			last_rosterCount = rosterSize;
			last_rosterCount = rosterSize;
			settledCount = rosterSize;
		end
		
		local workingRoster = {};
		local scanning = false;
		local incompleteScans = {};
		local scancount = 0;
		local lastTime = -1;
		local groupTilAvg;
		local sourcesIncluded, sourcesAvailable;
		local removeList = {};
		local BarMaxTotal;
		
--options page--------------------------------------------
----------------------------------------------------------

	--[[
	--register the page with the interface as a child
		til_optionpage.childpanel 			= 	CreateFrame("Frame", "til_optionpage_GROUP", til_optionpage.panel);
		til_optionpage.childpanel.name	 	= 	"Plugin: Group";
		til_optionpage.childpanel.okay		= 	function (self) tilgroup_optionpageOnOkay(); end;
		til_optionpage.childpanel.cancel	= 	function (self)  tilgroup_optionpageOnCancel();  end;
		til_optionpage.childpanel.parent	=	til_optionpage.panel.name;
		InterfaceOptions_AddCategory(til_optionpage.childpanel);
	
	--place objects into the options frame
		--coming soon notice
			local comingsoon = til_optionpage_GROUP:CreateFontString("comingsoon_label","OVERLAY");
			comingsoon:SetFontObject(GameFontNormalSmall);
			comingsoon:SetJustifyH("Center");
			comingsoon:ClearAllPoints();
			comingsoon:SetParent("til_optionpage_GROUP");
			comingsoon:SetPoint("CENTER", "til_optionpage_GROUP", "CENTER", 0, 0);
			comingsoon:SetText("Options page for 'Plugin: Group' is coming soon...");
			
	--handle button events	
		function tilgroup_optionpageOnOkay(panel)
			--okay button was pressed (this also triggers the same event for the parent addon)
		end
		
		function tilgroup_optionpageOnCancel(panel)
			--cancel button was pressed (this also triggers the same event for the parent addon)
		end
	--]]
	
--create addon frames-------------------------------------
----------------------------------------------------------

	--frame wrapper for public functions
		tilgroup = CreateFrame("Frame","tilgroup");
	
	--register frame wrapper for events
		tilgroup:SetScript('OnEvent', function(self, event, ...) self[event](self, event, ...) end);
			tilgroup:RegisterEvent("PLAYER_LOGIN");
			tilgroup:RegisterEvent("PARTY_MEMBERS_CHANGED");
			tilgroup:RegisterEvent("RAID_ROSTER_UPDATE");
			tilgroup:RegisterEvent("PLAYER_ENTERING_WORLD");
	
	--create our tab space in the til ui
		--get our tabIndex
		local tabIndex = tilui:addTab("|cff"..party_c.."My Group|r");
			local tabName = ("tilFrameTab"..tabIndex);
			local headerName = ("tilFramePage"..tabIndex.."Header");
			_G[headerName]:SetText("|cff"..party_c.."Scan & View My Group|r");
	
			--create the table
			local tableSchema = {
			   {7,			7,			21,			15,			8,			8,			8,			8,			18			},	--column width percent
			   {"Lvl",		"Cls",		"Name",		"Spec",		"TIL",		"BOA", 		"PVP",		"MIA",		"Status"	},		--column header
			   {"lvl",		"class",	"name",		"spec",		"til",		"boa",		"pvp",		"mia",		"scanstatus"},	--what keys the column is looking for
			   {"level",	"class",	"class",	"aaaaaa",	til_c,		boa_c,		pvp_c,		miss_c,		"888888"	},	--the color for each column in hex or special tag
			   
			   { --table configuration options
				   sortCol		=	5,
				   sortMode		=	"desc",
				   classCol		=	2,
				   levelCol		=	1,
			   }
			};

				
			--display columns
			tilui:createTable(tabIndex,tableSchema);
	
	--create the scan button
		local scanButton = CreateFrame("Button","tilgroupScanButton",_G["tilFramePage"..tabIndex],"UIPanelButtonTemplate2");
			scanButton:SetWidth(80);
			scanButton:SetHeight(20);
			scanButton:SetPoint("TOPLEFT","tilFrame","TOPLEFT",70,-42);
			scanButton:SetNormalFontObject("GameFontNormalSmall");
			scanButton:SetHighlightFontObject("GameFontNormalSmall");
			scanButton:SetDisabledFontObject("GameFontNormalSmall");
			scanButton:SetText("Scan All");
			scanButton:Disable();
			scanButton:SetScript("OnClick", function (self, ...)
				scanStartTime = time();
				self:Disable();
				_G["tilgroupScanNewButton"]:Disable();
				_G["grouptiltext"]:SetText("|cff555555Please Wait...|r");
				--print('scan started at: '..scanStartTime);
				scancount = 0;
				tilgroup:updateProgressBar(nil, nil, nil, "005588");
				workingRoster = CopyTable(rosterCache);
				doNextScan();
			end);
			
		local scanButton2 = CreateFrame("Button","tilgroupScanNewButton",_G["tilFramePage"..tabIndex],"UIPanelButtonTemplate2");
			scanButton2:SetWidth(80);
			scanButton2:SetHeight(20);
			scanButton2:SetPoint("LEFT","tilgroupScanButton","RIGHT",2,0);
			scanButton2:SetNormalFontObject("GameFontNormalSmall");
			scanButton2:SetHighlightFontObject("GameFontNormalSmall");
			scanButton2:SetDisabledFontObject("GameFontNormalSmall");
			scanButton2:SetText("Scan Missing");
			scanButton2:SetScript("OnClick", function (self, ...)
				for i, v in ipairs(rosterCache) do
					if (rosterCache[i].scanstatus == tagNew) then
						tinsert(workingRoster,rosterCache[i]);
					end
				end
				
				self:Disable();
				scanButton:Disable();
				
				_G["grouptiltext"]:SetText("|cff555555Please Wait...|r");
				scancount = 0;
				tilgroup:updateProgressBar(nil, nil, nil, "005588");
				local numToScan = #workingRoster;
				doNextScan(numToScan);
				
				--[[
				self:Disable();
				scanButton:Disable();
				_G["grouptiltext"]:SetText("|cff555555Please Wait...|r");
				--]]
			end);
			
		local scanButton3 = CreateFrame("Button","tilgroupResetButton",_G["tilFramePage"..tabIndex],"UIPanelButtonTemplate2");
			scanButton3:SetWidth(80);
			scanButton3:SetHeight(20);
			scanButton3:SetPoint("LEFT","tilgroupScanNewButton","RIGHT",2,0);
			scanButton3:SetNormalFontObject("GameFontNormalSmall");
			scanButton3:SetHighlightFontObject("GameFontNormalSmall");
			scanButton3:SetDisabledFontObject("GameFontNormalSmall");
			scanButton3:SetText("Reset");
			scanButton3:SetScript("OnClick", function (self, ...)
				rosterCache = nil;
				rosterCache = {};
				tilgroup:settleRoster(true);
			end);
			
	--create the group til counter frame
	local grouptil = CreateFrame("Frame","grouptilframe",_G["tilFramePage"..tabIndex]);
		grouptil:SetWidth(120);
		grouptil:SetHeight(30);
		grouptil:SetBackdrop( { 
			bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
			edgeFile = "Interface/Tooltips/UI-Tooltip-Border",
			tile = true, tileSize = 16, edgeSize = 16, 
			insets = { left = 4, right = 4, top = 4, bottom = 4}
		});
		grouptil:SetBackdropColor(0,0,0,.5);
		grouptil:SetBackdropBorderColor(1,1,1,.5);
		grouptil:SetPoint("TOP","tilFramePage"..tabIndex,"TOP",0,-33);
		grouptil:SetPoint("RIGHT","tilFramePage"..tabIndex.."ListRegion","RIGHT",0,0);
		grouptil:SetPoint("LEFT","tilgroupResetButton","RIGHT",2,0);
		grouptil:Show();
		
		--create text entries for counter frame
		local grouptiltext = grouptil:CreateFontString("grouptiltext","OVERLAY");
			grouptiltext:SetFontObject(GameFontNormal);
			grouptiltext:SetJustifyH("Center");
			grouptiltext:ClearAllPoints();
			grouptiltext:SetParent("grouptilframe");
			grouptiltext:SetPoint("CENTER", "grouptilframe", "CENTER", 0, 0);
			grouptiltext:SetText("");
			grouptiltext:SetTextColor(0,.8,1,1);
		local grouptiltextlabel = grouptil:CreateFontString("grouptiltextlabel","OVERLAY");
			grouptiltextlabel:SetFontObject(GameFontNormalSmall);
			grouptiltextlabel:SetJustifyH("Left");
			grouptiltextlabel:ClearAllPoints();
			grouptiltextlabel:SetParent("grouptilframe");
			grouptiltextlabel:SetPoint("LEFT", "grouptilframe", "TOPLEFT", 3, -4);
			grouptiltextlabel:SetFont("Fonts\\FRIZQT__.TTF", 9, "OUTLINE");
			grouptiltextlabel:SetText("Group TIL");
			grouptiltextlabel:SetTextColor(1,1,1,1);
	
	--create publish button
	local info = {};
	function initPublishDrop()
		info.text = "|cffffcc00Publish Entire List|r";
		info.isTitle = true;
		info.notCheckable = true;
		UIDropDownMenu_AddButton(info);
		wipe(info);
		
		info.text = "Say"
		info.notCheckable = true;
		info.func = function()
			tilgroup:publishToChat("SAY");
		end;
		UIDropDownMenu_AddButton(info);
		wipe(info)
		
		info.text = "Guild"
		info.notCheckable = true;
		info.func = function()
			tilgroup:publishToChat("GUILD");
		end;
		UIDropDownMenu_AddButton(info);
		wipe(info);
		
		info.text = "Group (Raid/Party)"
		info.notCheckable = true;
		info.func = function()
			tilgroup:publishToChat("GROUP");
		end;
		UIDropDownMenu_AddButton(info);
		wipe(info);
		
		info.text = " ";
		info.isTitle = true;
		info.notCheckable = true;
		UIDropDownMenu_AddButton(info);
		wipe(info);

		
		info.text = "|cffffcc00Publish Group TIL Only|r";
		info.isTitle = true;
		info.notCheckable = true;
		UIDropDownMenu_AddButton(info);
		wipe(info);
		
		info.text = "Say"
		info.notCheckable = true;
		info.func = function()
			tilgroup:publishToChat("SAY",true);
		end;
		UIDropDownMenu_AddButton(info);
		wipe(info)
		
		info.text = "Guild"
		info.notCheckable = true;
		info.func = function()
			tilgroup:publishToChat("GUILD",true);
		end;
		UIDropDownMenu_AddButton(info);
		wipe(info);
		
		info.text = "Group (Raid/Party)"
		info.notCheckable = true;
		info.func = function()
			tilgroup:publishToChat("GROUP",true);
		end;
		UIDropDownMenu_AddButton(info);
		wipe(info);
	end
	
	local grouptilpublish = CreateFrame("Button","tilgroupPublishButton",_G["tilFramePage"..tabIndex],"tilPublishButton");
		grouptilpublish:ClearAllPoints();
		grouptilpublish:SetPoint("BOTTOMLEFT",_G["tilFramePage"..tabIndex.."ListRegion"],"TOPRIGHT",-2,0);
		grouptilpublish:SetHeight(30);
		grouptilpublish:SetWidth(30);
		grouptilpublish:Show();
		grouptilpublish:SetScript("OnEnter", function(self,...)
			GameTooltip:SetOwner(self,"ANCHOR_TOPLEFT");
			GameTooltip:SetText("Click here to publish the group's TIL data.", nil, nil, nil, nil, 1);
			GameTooltip:Show();
		end);
		grouptilpublish:SetScript("OnClick", function(self,...)
			ToggleDropDownMenu(1, nil, _G["tilgrouppublishdrop"], self, 0, 0);
		end);
		
		--create button dropdown
		local grouptilpublishdrop = CreateFrame("Frame","tilgrouppublishdrop",UIParent,"UIDropDownMenuTemplate");
		UIDropDownMenu_Initialize(grouptilpublishdrop, initPublishDrop, "MENU");
		grouptilpublishdrop:ClearAllPoints();
		grouptilpublishdrop:SetPoint("TOPLEFT",grouptilpublish,"TOPRIGHT",0,0);
			
	--create the progress bar
		local progressBar = CreateFrame("Frame","tilgroupProgressBar",_G["tilFramePage"..tabIndex],"tilProgressBarTemplate");
			progressBar:SetPoint("TOPLEFT",_G["tilFramePage"..tabIndex.."ListRegion"],"BOTTOMLEFT",0,-3);
			progressBar:SetPoint("TOPRIGHT",_G["tilFramePage"..tabIndex.."ListRegion"],"BOTTOMRIGHT",20,0);
			
	--settleRoster timer frame
		tilgroup_settleRoster = CreateFrame("Frame","tilgroup_settleRoster");
			tilgroup_settleRoster:Hide();
			tilgroup_settleRoster:SetScript("OnUpdate",function(self,elapsed)
				if (time() ~= lastTime) then
					local tminus = abs(time() - rosterNextUpdate);
					lastTime = time();
					tilgroup:updateProgressBar(tminus,rosterSettleTime, "Checking Roster For Changes", "ff9e00");
				end
				if (time() >= rosterNextUpdate) then
					self:Hide();
					--the roster is settled
					tilgroup:updateProgressBar(0,0, tagReady,"005588")
					if (scanButton) then
						scanButton:Enable();
						scanButton2:Enable();
					end
					rosterSettled();
				end
			end);
			tilgroup_settleRoster:SetScript("OnShow",function(self,...)
				--settling the roster
				tilgroup:updateProgressBar(100,100, "Checking Roster For Changes", "ff9e00")
				grouptiltext:SetText("|cff555555Please Wait...|r");
				grouptiltextlabel:SetTextColor(.8,.8,.8,1);
				grouptil:SetBackdropBorderColor(.8,.8,.8,1);
					if (scanButton) then
						scanButton:Disable();
						scanButton2:Disable();
					end
			end);
			
--ui element functions------------------------------------
----------------------------------------------------------

	function tilgroup:updateProgressBar(num, maxNum, msg, color)
		if(num and maxNum) then
			local barWidth = _G[progressBar:GetName()]:GetWidth() - 2;
			local decimal = num/maxNum;
			local percent = ceil(decimal * barWidth);
			if (percent > barWidth) then
				percent = barWidth;
			end
			
			_G[progressBar:GetName().."Progress"]:SetWidth(percent);
			
			if (percent == 0) then
				_G[progressBar:GetName().."Progress"]:Hide();
			else
				_G[progressBar:GetName().."Progress"]:Show();
			end
		end
		if (msg) then
			_G[progressBar:GetName().."Text"]:SetText(msg);
		end
		
		if (color) then
			local red, green, blue = tilui:HexToRGBPerc(color);
			_G[progressBar:GetName().."Progress"]:SetVertexColor(red,green,blue,1);
		end
	end

--event functions-----------------------------------------
----------------------------------------------------------

	function tilgroup:publishToChat(where,groupOnly) --GROUP, GUILD
		if (where == "GROUP") then
			--raid or 5 man? figure it out and set where to the right place
			if (UnitInRaid("player")) then
				where = "RAID";
			elseif (UnitInParty("player")) then
				where = "PARTY";
			end
		end
			
		if (not groupOnly) then
			local msg;
			--[[
				msg = ("[TIL]: Group iLVL: "..groupTilAvg.." ("..sourcesIncluded.."/"..sourcesAvailable.." sources)");
				SendChatMessage(msg , where);
			--]]
			
			local unscanned = "";
			local count = 0;
			for i, v in ipairs (savedData[tabIndex]) do
				--add our server name as a default
				local name;
				local serverMatch = string.find(savedData[tabIndex][i][3],' - ');
				
				if (serverMatch and serverMatch > 0) then
					name = savedData[tabIndex][i][3];
				else
					name = (savedData[tabIndex][i][3]..' - '..serverName);
				end
				if (savedData[tabIndex][i][9] ~= tagNew) then
					count = count + 1;
					--get the outputline
					local outputLine = (count..". "..name..": "..savedData[tabIndex][i][5]);
					if (savedData[tabIndex][i][6] > 0) then
						--boa found
						outputLine = outputLine.." ("..savedData[tabIndex][i][6].." BOA)"
					end
					if (savedData[tabIndex][i][7] > 0) then
						--pvp found
						outputLine = outputLine.." ("..savedData[tabIndex][i][7].." PVP)"
					end
					if (savedData[tabIndex][i][8] > 0) then
						--mia found
						outputLine = outputLine.." ("..savedData[tabIndex][i][8].." MIA)"
					end
					msg = (outputLine);
					SendChatMessage(msg , where);
				else
					unscanned = unscanned..name..", ";
				end
			end
			if (sourcesAvailable > sourcesIncluded) then
				--print the unscanned list
				msg = ("[TIL]: Unscanned Players ("..sourcesAvailable - sourcesIncluded.."): ");
				msg = (msg..unscanned);
				SendChatMessage(msg , where);
			end
			msg = ("[TIL]: Group iLVL: "..groupTilAvg.." ("..sourcesIncluded.."/"..sourcesAvailable.." sources)");
			SendChatMessage(msg , where);
		else
			msg = ("[TIL]: Group iLVL: "..groupTilAvg.." ("..sourcesIncluded.."/"..sourcesAvailable.." sources)");
			SendChatMessage(msg , where);
		end
	end
	
	function tilgroup:settleRoster(force)
		--flush the roster of old entries
		
		if (UnitInRaid("player")) then
			partyType = "RAID";
			rosterCount = GetNumRaidMembers() + 1;
		elseif (UnitInParty("player")) then
			partyType = "PARTY";
			rosterCount = GetNumPartyMembers() + 1;
		end
		if (rosterCount == 1) then
			--delete the rosterCache since we are not in a group
			--wipe(rosterCache);
			partyType = "SOLO";
		end

		if (rosterSize ~= rosterCount or force == true) then
			--the currently counted roster is for a group, but is a different size than the last time we checked, so we need to settle the roster
			last_rosterCount = rosterCount;
			rosterSize = rosterCount;
			rosterNextUpdate = (time() + rosterSettleTime);
			tilgroup_settleRoster:Show();
		end
	end
	
	function rosterSettled()
		scanButton:Enable();
		scanButton2:Enable();
		settledCount = rosterCount;
		
		--set the color and label of the til interface tab to match raid or group
		local checkSpots, unitPre;
		
		if (partyType == "RAID") then
			unitPre = "raid";
		else
			unitPre = "party";
		end

		if (settledCount <= 0) then
			scanButton:Disable();
			scanButton2:Disable();
		else
			scanButton:Enable();
			scanButton2:Enable();
		end
		
		--add or update all units into the rosterCache
		tilgroup:addMissing(unitPre);
		
		--update group's average til and purge old data from rosterCache
		tilgroup:purgeNonGroup();
		tilgroup:getGroupTil();
	end
	
	function tilgroup:addMissing(unitPre)
		local count = 0;
		
		if (unitPre == "raid") then
			--raid
			--using the api GetRaidRosterInfo to hopefully avoid combat lockdown issues
			for i = 1, 40 do
				local name, rank, subgroup, level, class, fileName, zone, online, isDead, role, isML = GetRaidRosterInfo(i);
				if (name) then
					local findDash = string.find(name,'%-');
					if (findDash) then
						--cross realm names don't have proper spacing before and after the dash, so this is where we fix it!
						local findSpaces = string.find(name,'%s%-%s');
						if (not findSpaces) then
							name = string.gsub(name,"-"," - ",1);
						end
					end
				end
				
				local found = tilgroup:checkCacheByName(name);
				if (found) then
					--the unit is already in the cache, so just set it's reference
					rosterCache[found].reference = unitPre..i;
				else
					--we need to add the unit to our saved roster (if they exist)).
					if (name) then
						tinsert(rosterCache,{
							["class"]		=	fileName,
							["lvl"]			=	level,
							["name"]		=	name,
							["til"]			=	0,
							["spec"]		=	"",
							["boa"]			=	0,
							["pvp"]			=	0,
							["mia"]			=	0,
							["reference"]	=	unitPre..i,
							["scanstatus"]	=	tagNew,
						});
					end
				end
			end
		else
			--party
			for i = 1, 5 do
				if (i == 5) then
					--there is no party5 UnitID, so use this spot to handle the player information
					local unitName			=	GetUnitName("player");
					local lClass, eClass	=	UnitClass("player");
					local unitLevel			=	UnitLevel("player");
					local found = tilgroup:checkCacheByName(unitName);
					if (found) then
						--the player is already in the cache, so just set it's reference
						rosterCache[found].reference = "player";
					else
						--we need to add the player to our saved roster.
						tinsert(rosterCache,{
							["class"]		=	eClass,
							["lvl"]			=	unitLevel,
							["name"]		=	unitName,
							["til"]			=	0,
							["spec"]		=	"",
							["boa"]			=	0,
							["pvp"]			=	0,
							["mia"]			=	0,
							["reference"]	=	"player",
							["scanstatus"]	=	tagNew,
						});
					end
				else
					--handle the party member info
					local unitName			=	GetUnitName(unitPre..i,true);
					local lClass, eClass	=	UnitClass(unitPre..i);
					local unitLevel			=	UnitLevel(unitPre..i);
					local found = tilgroup:checkCacheByName(unitName);
					if (found) then
						--the unit is already in the cache, so just set it's reference
						rosterCache[found].reference = unitPre..i;
					else
						--we need to add the unit to our saved roster (if they exist)).
						if (unitName) then
							tinsert(rosterCache,{
								["class"]		=	eClass,
								["lvl"]			=	unitLevel,
								["name"]		=	unitName,
								["til"]			=	0,
								["spec"]		=	"",
								["boa"]			=	0,
								["pvp"]			=	0,
								["mia"]			=	0,
								["reference"]	=	unitPre..i,
								["scanstatus"]	=	tagNew,
							});
						end
					end
				end
			end
		end
		
		--[[
		for i = 1, checkSpots do
			if (i == 5 and unitPre ~= "raid") then
				--add the player to the workingCache since partyN doesn't include the player by default like raidN does.
				count = count + 1;
				local unitName = (GetUnitName("player",true));
				local lClass, eClass = UnitClass("player");
				local unitLevel = UnitLevel("player");
				
				local found = tilgroup:checkCacheByName(unitName);
				if (found) then
					--found the unit in the cache, reference doesn't change for the player
					rosterCache[found].reference = "player";
				else
					--unit was not found in the cache, so we need to add them with 'unscanned' status
					rosterCache[#rosterCache + 1] = {
						["lvl"]		=	unitLevel,
						["class"]	=	eClass,
						["name"]	=	unitName,
						["til"]		=	0,
						["spec"]	=	"",
						["boa"]		=	0,
						["pvp"]		=	0,
						["mia"]		=	0,
						["scanstatus"]	=	tagNew,
						["reference"] = "player",
					}
				end				
			else
				if (UnitExists(unitPre..i)) then
					--add the unit to the working roster
					count = count + 1;
					
					local unitName = GetUnitName(unitPre..i,true);
					local lClass, eClass = UnitClass(unitPre..i);
					local unitLevel = UnitLevel(unitPre..i);

					local found = tilgroup:checkCacheByName(unitName);
					if (found) then
						--found the unit in the cache, update it's reference
						rosterCache[found].reference = unitPre..i;
					else
						--unit was not found in the cache, so we need to add them with 'unscanned' status
						rosterCache[#rosterCache + 1] = {
							["lvl"]		=	unitLevel,
							["class"]	=	eClass,
							["name"]	=	unitName,
							["til"]		=	0,
							["spec"]	=	"",
							["boa"]		=	0,
							["pvp"]		=	0,
							["mia"]		=	0,
							["scanstatus"]	=	tagNew,
							["reference"] = unitPre..i,
						}
					end
				end
			end
		end
		--]]
		
		tilui:fillTable(tabIndex,rosterCache);
	end
	
	function tilgroup:fillCrap()
			tinsert(rosterCache,{
				["class"]		=	"WARRIOR",
				["lvl"]			=	85,
				["name"]		=	"DOCTOR AWESOME",
				["til"]			=	9000,
				["spec"]		=	"PEDIATRY",
				["boa"]			=	0,
				["pvp"]			=	17,
				["mia"]			=	0,
				["reference"]	=	"party1",
				["scanstatus"]	=	tagNew,
			});
			tinsert(rosterCache,{
				["class"]		=	"MAGE",
				["lvl"]			=	85,
				["name"]		=	"MAGE TIME",
				["til"]			=	9000,
				["spec"]		=	"PEDIATRY",
				["boa"]			=	0,
				["pvp"]			=	17,
				["mia"]			=	0,
				["reference"]	=	"party2",
				["scanstatus"]	=	tagNew,
			});
			tinsert(rosterCache,{
				["class"]		=	"DEATHKNIGHT",
				["lvl"]			=	85,
				["name"]		=	"DOCTOR DK",
				["til"]			=	9000,
				["spec"]		=	"PEDIATRY",
				["boa"]			=	0,
				["pvp"]			=	17,
				["mia"]			=	0,
				["reference"]	=	"party3",
				["scanstatus"]	=	tagNew,
			});
			tinsert(rosterCache,{
				["class"]		=	"DRUID",
				["lvl"]			=	85,
				["name"]		=	"DROOD RUNNER",
				["til"]			=	9000,
				["spec"]		=	"PEDIATRY",
				["boa"]			=	0,
				["pvp"]			=	17,
				["mia"]			=	0,
				["reference"]	=	"party4",
				["scanstatus"]	=	tagNew,
			});
		
		tilui:fillTable(tabIndex,rosterCache);
	end

	function tilgroup:purgeNonGroup()
		--try to get the name of the unit by referencing the name we have stored.
		--if the level isn't returned, then they are not in the raid/party
		
		local searching = true;
		local removedEntry;
		
		while (searching == true) do
			removedEntry = false;
			
			for k, v in pairs(rosterCache) do
				local name = { strsplit(" - ", rosterCache[k].name) };				
				if (UnitName(name[1])) then
					--keeping in the roster
					--print('|cff00ff00Keeping '..rosterCache[k].name..' in the roster|r');
				else
					--couldn't fetch the name by exact name reference, so they must not be in the roster.
					--print('|cffff0000deleting '..rosterCache[k].name..' from roster listing|r');
					removedEntry = true;
					tremove(rosterCache,k);
					break;
				end
			end
			
			if (removedEntry) then
				searching = true;
			else
				searching = false;
			end
		end
		
		
		--[[ old method recursively searches through every potential raid/group spot
		--print('looking through '..#rosterCache..' entries to see what needs to be purged');
		for i = 1, #rosterCache do
			local found = false;
			if (i and rosterCache[i] and rosterCache[i].name) then
				--print(i..'. looking in group for '..rosterCache[i].name);
				found =  tilgroup:checkRosterByName(rosterCache[i].name,partyType);
					
				if (not found) then
					--the entry in the cache should be purged
					--print("|cffff0000couldn't find "..rosterCache[i].name.." in the current roster - deleting|r");
					rosterCache[i] = nil;
				else
					--print("|cff00ccfffound "..rosterCache[i].name.." in the current roster - keeping|r");
				end
			end
		end
		--]]
		
		tilui:fillTable(tabIndex,rosterCache);
	end
	
	function tilgroup:checkCacheByName(name)
		for i, v in ipairs(rosterCache) do
			if (rosterCache[i].name == name) then
				return i;
			end
		end
		
		return false;
	end
	
	function tilgroup:checkRosterByName(name,partyType)
		if (name == UnitName("player")) then
			return true;
		else
			local found = false;
			local slots, prefix;
			
			if (partyType == "RAID") then
				slots = 40;
				prefix = "raid";
			else
				slots = 4;
				prefix = "party";
			end
			
			
			for i = 1, slots do
				if (name == GetUnitName(prefix..i,true)) then
					found = true;
				end
				if (found) then break; end
			end
			return found;
		end
	end
	
	function tilgroup:RAID_ROSTER_UPDATE()
		tilgroup:settleRoster();
	end
	
	function tilgroup:PARTY_MEMBERS_CHANGED()
		tilgroup:settleRoster();
	end
	
	function tilgroup:PLAYER_ENTERING_WORLD()
		tilgroup:settleRoster(true);
	end
	
	function tilgroup:PLAYER_LOGIN()
		tilgroup:settleRoster(true);
	end

	function UnitInRoster(unit)
		if (partyType == "RAID") then
			return (UnitInRaid(unit));
		else
			return (UnitInParty(unit));
		end
	end
	
	function tilgroup_scanupdate(step, data, arg1)
		if (step ~= "failed") then
			if (step == "cache") then
			
			elseif (step == "started") then
			
			elseif (step == 'rescanning') then
			
			elseif (step == "talents") then
			
			elseif (step == "items") then
				if (data.til >= 1) then
					if (data.name == UnitName("player").." - "..serverName) then
						data.name = UnitName("player");
					end
					local found = tilgroup:checkCacheByName(data.name);
					if (found) then
						--delete the existing entry
						local reference = rosterCache[found].reference;
						tremove(rosterCache,found);
						
						--add the updated entry
						tinsert(rosterCache, {
							["lvl"]			=	data.level,
							["class"]		=	data.class,
							["name"]		=	data.name,
							["til"]			=	data.til,
							["spec"]		=	data.tree,
							["boa"]			=	data.boa,
							["pvp"]			=	data.pvp,
							["mia"]			=	data.mia,
							["scanstatus"]	=	tagScanned,
							["reference"]	=	reference,
						});
					end
				else
					tilgroup:updateProgressBar(nil,nil,nil,"880000");
				end
				
				tilui:fillTable(tabIndex,rosterCache);
				doNextScan();
			end
		else
			if (data and arg1) then
				--print('scan failure: |cffff0000'..data..' '..arg1.."|r");
			elseif (data) then
				if (data == "invalid") then
					--print("scan failure: |cff00ff00out of range|r");
					--when one is out of range, they all become out of range
						-- queueing system might fix this?
				else
					--print("scan failure: |cffff0000invalid|r");
				end
			else
				--print("scan failure: |cffff0000unknown|r");
			end
			--print('doing next scan');
			tilgroup:updateProgressBar(nil,nil,nil,"880000");
			doNextScan();
		end
	end
	
	function doNextScan(numToScan)
		
		scancount = scancount + 1;
		if (not numToScan) then
			numToScan = settledCount;
		end
		
		if (#workingRoster > 0) then
			--print(#workingRoster..'. attempting to scan '..scancount..' ('..workingRoster[#workingRoster].name..')');
			tilgroup:updateProgressBar((scancount-1), (numToScan), "Scanning "..(scancount-1).."/"..#rosterCache);
			--we should get the first entry in workingRoster, send it to til pub, and delete it from workingRoster
			local reference = workingRoster[#workingRoster].reference;
			--print('gathering stats for UnitID: "'..reference..'" ('..GetUnitName(reference,true)..') 1 of '..#workingRoster);
			
			tremove(workingRoster,#workingRoster);
			--print('workingRoster now has '..#workingRoster);
			tilpub:gatherstats(reference,"tilgroup","tilgroup_scanupdate");
		else
			scancount = 0;
			
			--is there anything missing?
			local missingcount = 0;
			for i, v in ipairs(rosterCache) do
				if (rosterCache[i].scanstatus == tagNew) then
					missingcount = missingcount + 1;
				end
			end
			
			if (missingcount > 0) then
				--update the bar
				tilgroup:updateProgressBar(1, 1, missingcount.." player(s) remain unscanned","880000");
			else
				tilgroup:updateProgressBar(1, 1, "Scan Complete",'008800');
			end
			
			scanButton:Enable();
			scanButton2:Enable();
			
			tilgroup:getGroupTil();
			
			tilpub:endControl('tilgroup');
		end
	--[[
		--print('doing next scan');
		if (scanButton:GetText() == "Scan Group") then
			scanButton:SetText("Cancel Scan");
		else
			scanButton:SetText("Scan Group");
		end
		
		--send a request to tilpub:gatherstats
		local matched = 0;
		
		local count = 0;
		
		while (matched <= 0 and count ~= #workingRoster) do
			count = count + 1;
			if (workingRoster[count].reference) then
				matched = count;
			end		
		end
		
		if (matched > 0) then
			--print('gathering stats for UnitID: "'..workingRoster[count].reference..'" ('..GetUnitName(workingRoster[count].reference,true)..').');
			tilpub:gatherstats(workingRoster[count].reference,"tilgroup","tilgroup_scanupdate");
			tremove(workingRoster,count);
		else
			--print('no unit left to scan');
		end
		
		for i = 1, #workingRoster do
			if (matched) then break; end
			--print('checking workingRoster slot '..i..' /'..#workingRoster);
			--begin the chain for tilpub:gatherstats() of each unit in the workingRoster
			if (workingRoster[i]) then
				matched = true;
				--print('gathering stats for UnitID: "'..workingRoster[i].reference..'" ('..GetUnitName(workingRoster[i].reference,true)..').');
				tilpub:gatherstats(workingRoster[i].reference,"tilgroup","tilgroup_scanupdate");
				tremove(workingRoster,i);
				break;
			else
				--print('workingRoster index '..i..' not found...');
			end
		end
		--]]
	end
	
	function tilgroup:getGroupTil()
			
			local totalCount = #rosterCache;
			local missing = false;
			local missingCount = 0;
			local tilAdded = 0;
			local tilavg;
			
			for i, v in ipairs(rosterCache) do
			
				if (rosterCache[i].scanstatus == tagNew) then
					missing = true;
					missingCount = missingCount + 1;
				else
					tilAdded = tilAdded + rosterCache[i].til;
				end
			end
			
			if (tilAdded == 0) then
				tilavg = 0;
			else
				tilavg = floor(tilAdded / (totalCount - missingCount));
			end
			
			grouptiltext:SetText(tilavg.." |cff555555("..(#rosterCache - missingCount).."/"..#rosterCache..")|r");
			
			groupTilAvg = tilavg;
			
			sourcesIncluded = totalCount - missingCount;
			sourcesAvailable = totalCount;
			
			if (missing) then
				grouptiltext:SetTextColor(1,.62,0,1);
				grouptiltextlabel:SetTextColor(1,.62,0,1);
				grouptil:SetBackdropBorderColor(1,.62,0,01);
			else
				grouptiltext:SetTextColor(0,.8,0,1);
				grouptiltextlabel:SetTextColor(0,.8,0,1);
				grouptil:SetBackdropBorderColor(0,.8,0,1);
			end
			
			--update tab and headers of the page
		local tabText, headerText, checkSpots, unitPre;
		
		if (partyType == "RAID") then
			tabText =		("|cff"..raid_c.."My Raid ("..sourcesAvailable..")|r");
			headerText =	("|cff"..raid_c.."Scan & View My Raid [BETA]|r");
			unitPre = "raid";
		else
			tabText =		("|cff"..party_c.."My Group ("..sourcesAvailable..")|r");
			headerText =	("|cff"..party_c.."Scan & View My Group [BETA]|r");
			unitPre = "party";
		end
		
		_G[tabName]:SetText(tabText);
		_G[tabName]:Hide();
		_G[tabName]:Show();
		_G[headerName]:SetText(headerText);
			
			
		tilui:fillTable(tabIndex,rosterCache);
	end